diff --git a/app/Http/Controllers/Web/ProfileController.php b/app/Http/Controllers/Web/ProfileController.php
index 6fd6a37..393a6b2 100644
--- a/app/Http/Controllers/Web/ProfileController.php
+++ b/app/Http/Controllers/Web/ProfileController.php
@@ -3,11 +3,8 @@
 namespace Portal\Http\Controllers\Web;
 
 use Portal\Events\User\ChangedAvatar;
-use Portal\Events\User\TwoFactorDisabled;
-use Portal\Events\User\TwoFactorEnabled;
 use Portal\Events\User\UpdatedProfileDetails;
 use Portal\Http\Controllers\Controller;
-use Portal\Http\Requests\User\EnableTwoFactorRequest;
 use Portal\Http\Requests\User\UpdateProfileDetailsRequest;
 use Portal\Http\Requests\User\UpdateProfileLoginDetailsRequest;
 use Portal\Repositories\Activity\ActivityRepository;
@@ -19,7 +16,6 @@ use Portal\Services\Upload\UserAvatarManager;
 use Portal\Support\Enum\UserStatus;
 use Portal\User;
 use Auth;
-use Authy;
 use Illuminate\Http\Request;
 
 /**
@@ -32,6 +28,7 @@ class ProfileController extends Controller
      * @var User
      */
     protected $theUser;
+
     /**
      * @var UserRepository
      */
@@ -101,9 +98,7 @@ class ProfileController extends Controller
      */
     public function updateAvatar(Request $request, UserAvatarManager $avatarManager)
     {
-        $this->validate($request, [
-            'avatar' => 'image'
-        ]);
+        $request->validate(['avatar' => 'image']);
 
         $name = $avatarManager->uploadAndCropAvatar(
             $this->theUser,
@@ -174,53 +169,6 @@ class ProfileController extends Controller
             ->withSuccess(trans('app.login_updated'));
     }
 
-    /**
-     * Enable 2FA for currently logged user.
-     *
-     * @param EnableTwoFactorRequest $request
-     * @return \Illuminate\Http\RedirectResponse
-     */
-    public function enableTwoFactorAuth(EnableTwoFactorRequest $request)
-    {
-        if (Authy::isEnabled($this->theUser)) {
-            return redirect()->route('user.edit', $this->theUser->id)
-                ->withErrors(trans('app.2fa_already_enabled'));
-        }
-
-        $this->theUser->setAuthPhoneInformation($request->country_code, $request->phone_number);
-
-        Authy::register($this->theUser);
-
-        $this->theUser->save();
-
-        event(new TwoFactorEnabled);
-
-        return redirect()->route('profile')
-            ->withSuccess(trans('app.2fa_enabled'));
-    }
-
-    /**
-     * Disable 2FA for currently logged user.
-     *
-     * @return \Illuminate\Http\RedirectResponse
-     */
-    public function disableTwoFactorAuth()
-    {
-        if (! Authy::isEnabled($this->theUser)) {
-            return redirect()->route('profile')
-                ->withErrors(trans('app.2fa_not_enabled_for_this_user'));
-        }
-
-        Authy::delete($this->theUser);
-
-        $this->theUser->save();
-
-        event(new TwoFactorDisabled);
-
-        return redirect()->route('profile')
-            ->withSuccess(trans('app.2fa_disabled'));
-    }
-
     /**
      * Display user activity log.
      *
diff --git a/app/Http/Controllers/Web/TwoFactorController.php b/app/Http/Controllers/Web/TwoFactorController.php
new file mode 100644
index 0000000..fd45f68
--- /dev/null
+++ b/app/Http/Controllers/Web/TwoFactorController.php
@@ -0,0 +1,137 @@
+<?php
+
+namespace Portal\Http\Controllers\Web;
+
+use Portal\Events\User\TwoFactorDisabled;
+use Portal\Events\User\TwoFactorEnabled;
+use Portal\Events\User\TwoFactorEnabledByAdmin;
+use Portal\Http\Controllers\Controller;
+use Portal\Http\Requests\TwoFactor\DisableTwoFactorRequest;
+use Portal\Http\Requests\TwoFactor\EnableTwoFactorRequest;
+use Portal\Http\Requests\TwoFactor\ReSendTwoFactorTokenRequest;
+use Portal\Http\Requests\TwoFactor\VerifyTwoFactorTokenRequest;
+use Authy;
+use Portal\Repositories\User\UserRepository;
+
+/**
+ * Class ProfileController
+ * @package Portal\Http\Controllers
+ */
+class TwoFactorController extends Controller
+{
+    public function __construct(UserRepository $users)
+    {
+        $this->middleware('auth');
+
+        $this->middleware(function ($request, $next) use ($users) {
+            $user = $request->get('user')
+                ? $users->find($request->get('user'))
+                : auth()->user();
+
+            return Authy::isEnabled($user) ? abort(404) : $next($request);
+        })->only('enable', 'verification', 'resend', 'verify');
+    }
+
+    /**
+     * Enable 2FA for currently logged user.
+     *
+     * @param EnableTwoFactorRequest $request
+     * @return \Illuminate\Http\RedirectResponse
+     */
+    public function enable(EnableTwoFactorRequest $request)
+    {
+        $user = $request->theUser();
+
+        $user->setAuthPhoneInformation($request->country_code, $request->phone_number);
+
+        Authy::register($user);
+
+        $user->save();
+
+        Authy::sendTwoFactorVerificationToken($user);
+
+        return $user->is(auth()->user())
+            ? redirect()->route('two-factor.verification')
+            : redirect()->route('two-factor.verification', ['user' => $user->id]);
+    }
+
+    /**
+     * Show the phone verification page.
+     *
+     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
+     */
+    public function verification()
+    {
+        return view('user.two-factor-verification', [
+            'user' => request('user')
+        ]);
+    }
+
+    /**
+     * Re-send phone verification token.
+     * @param ReSendTwoFactorTokenRequest $request
+     */
+    public function resend(ReSendTwoFactorTokenRequest $request)
+    {
+        Authy::sendTwoFactorVerificationToken($request->theUser());
+    }
+
+    /**
+     * Verify 2FA token and enable 2FA if token is valid.
+     *
+     * @param VerifyTwoFactorTokenRequest $request
+     * @return \Illuminate\Http\RedirectResponse
+     */
+    public function verify(VerifyTwoFactorTokenRequest $request)
+    {
+        $user = $request->theUser();
+
+        if (! Authy::tokenIsValid($user, $request->token)) {
+            return redirect()->route('two-factor.verification')
+                ->withErrors(['token' => 'Invalid 2FA token.']);
+        }
+
+        $user->setTwoFactorAuthProviderOptions(array_merge(
+            $user->getTwoFactorAuthProviderOptions(),
+            ['enabled' => true]
+        ));
+
+        $user->save();
+
+        if ($user->is(auth()->user())) {
+            event(new TwoFactorEnabled);
+
+            return redirect()->route('profile')
+                ->withSuccess(trans('app.2fa_enabled'));
+        }
+
+        event(new TwoFactorEnabledByAdmin($user));
+
+        return redirect()->route('user.edit', $user->id)
+            ->withSuccess(trans('app.2fa_enabled'));
+    }
+
+    /**
+     * Disable 2FA for currently logged user.
+     *
+     * @param DisableTwoFactorRequest $request
+     * @return \Illuminate\Http\RedirectResponse
+     */
+    public function disable(DisableTwoFactorRequest $request)
+    {
+        $user = $request->theUser();
+
+        if (! Authy::isEnabled($user)) {
+            abort(404);
+        }
+
+        Authy::delete($user);
+
+        $user->save();
+
+        event(new TwoFactorDisabled);
+
+        return redirect()->back()
+            ->withSuccess(trans('app.2fa_disabled'));
+    }
+}
diff --git a/app/Http/Controllers/Web/UsersController.php b/app/Http/Controllers/Web/UsersController.php
index 1b93327..1aab6a7 100644
--- a/app/Http/Controllers/Web/UsersController.php
+++ b/app/Http/Controllers/Web/UsersController.php
@@ -4,12 +4,9 @@ namespace Portal\Http\Controllers\Web;
 
 use Portal\Events\User\Banned;
 use Portal\Events\User\Deleted;
-use Portal\Events\User\TwoFactorDisabledByAdmin;
-use Portal\Events\User\TwoFactorEnabledByAdmin;
 use Portal\Events\User\UpdatedByAdmin;
 use Portal\Http\Controllers\Controller;
 use Portal\Http\Requests\User\CreateUserRequest;
-use Portal\Http\Requests\User\EnableTwoFactorRequest;
 use Portal\Http\Requests\User\UpdateDetailsRequest;
 use Portal\Http\Requests\User\UpdateLoginDetailsRequest;
 use Portal\Repositories\Activity\ActivityRepository;
@@ -21,7 +18,6 @@ use Portal\Services\Upload\UserAvatarManager;
 use Portal\Support\Enum\UserStatus;
 use Portal\User;
 use Auth;
-use Authy;
 use Illuminate\Http\Request;
 use Illuminate\Support\Facades\Input;
 
@@ -206,6 +202,7 @@ class UsersController extends Controller
      * @param User $user
      * @param UserAvatarManager $avatarManager
      * @return mixed
+     * @throws \Illuminate\Validation\ValidationException
      */
     public function updateAvatar(User $user, UserAvatarManager $avatarManager, Request $request)
     {
@@ -295,56 +292,6 @@ class UsersController extends Controller
             ->withSuccess(trans('app.user_deleted'));
     }
 
-    /**
-     * Enables Authy Two-Factor Authentication for user.
-     *
-     * @param User $user
-     * @param EnableTwoFactorRequest $request
-     * @return \Illuminate\Http\RedirectResponse
-     */
-    public function enableTwoFactorAuth(User $user, EnableTwoFactorRequest $request)
-    {
-        if (Authy::isEnabled($user)) {
-            return redirect()->route('user.edit', $user->id)
-                ->withErrors(trans('app.2fa_already_enabled_user'));
-        }
-
-        $user->setAuthPhoneInformation($request->country_code, $request->phone_number);
-
-        Authy::register($user);
-
-        $user->save();
-
-        event(new TwoFactorEnabledByAdmin($user));
-
-        return redirect()->route('user.edit', $user->id)
-            ->withSuccess(trans('app.2fa_enabled'));
-    }
-
-    /**
-     * Disables Authy Two-Factor Authentication for user.
-     *
-     * @param User $user
-     * @return \Illuminate\Http\RedirectResponse
-     */
-    public function disableTwoFactorAuth(User $user)
-    {
-        if (! Authy::isEnabled($user)) {
-            return redirect()->route('user.edit', $user->id)
-                ->withErrors(trans('app.2fa_not_enabled_user'));
-        }
-
-        Authy::delete($user);
-
-        $user->save();
-
-        event(new TwoFactorDisabledByAdmin($user));
-
-        return redirect()->route('user.edit', $user->id)
-            ->withSuccess(trans('app.2fa_disabled'));
-    }
-
-
     /**
      * Displays the list with all active sessions for selected user.
      *
diff --git a/app/Http/Kernel.php b/app/Http/Kernel.php
index 7fcad59..c5fdd33 100644
--- a/app/Http/Kernel.php
+++ b/app/Http/Kernel.php
@@ -59,5 +59,6 @@ class Kernel extends HttpKernel
         'bindings' => \Illuminate\Routing\Middleware\SubstituteBindings::class,
         'throttle' => \Illuminate\Routing\Middleware\ThrottleRequests::class,
         'cache.headers' => \Illuminate\Http\Middleware\SetCacheHeaders::class,
+        'verify-2fa-phone' => \Portal\Http\Middleware\VerifyTwoFactorPhone::class
     ];
 }
diff --git a/app/Http/Middleware/VerifyTwoFactorPhone.php b/app/Http/Middleware/VerifyTwoFactorPhone.php
new file mode 100644
index 0000000..815736b
--- /dev/null
+++ b/app/Http/Middleware/VerifyTwoFactorPhone.php
@@ -0,0 +1,42 @@
+<?php
+
+namespace Portal\Http\Middleware;
+
+use Closure;
+use Portal\Repositories\User\UserRepository;
+
+class VerifyTwoFactorPhone
+{
+    /**
+     * Handle an incoming request.
+     *
+     * @param  \Illuminate\Http\Request  $request
+     * @param  \Closure  $next
+     * @return mixed
+     *
+     * @throws \Symfony\Component\HttpKernel\Exception\HttpException
+     */
+    public function handle($request, Closure $next)
+    {
+        $user = $this->getUser($request);
+
+        if ($user->two_factor_country_code && $user->two_factor_phone) {
+            return $next($request);
+        }
+
+        abort(404);
+    }
+
+    /**
+     * @param $request
+     * @return mixed
+     */
+    private function getUser($request)
+    {
+        if ($userId = $request->get('user')) {
+            return app(UserRepository::class)->find($userId);
+        }
+
+        return $request->user();
+    }
+}
diff --git a/app/Http/Requests/TwoFactor/DisableTwoFactorRequest.php b/app/Http/Requests/TwoFactor/DisableTwoFactorRequest.php
new file mode 100644
index 0000000..cf3ebbc
--- /dev/null
+++ b/app/Http/Requests/TwoFactor/DisableTwoFactorRequest.php
@@ -0,0 +1,11 @@
+<?php
+
+namespace Portal\Http\Requests\TwoFactor;
+
+use Portal\Http\Requests\Request;
+use Portal\Repositories\User\UserRepository;
+use Portal\User;
+
+class DisableTwoFactorRequest extends TwoFactorRequest
+{
+}
diff --git a/app/Http/Requests/User/EnableTwoFactorRequest.php b/app/Http/Requests/TwoFactor/EnableTwoFactorRequest.php
similarity index 67%
rename from app/Http/Requests/User/EnableTwoFactorRequest.php
rename to app/Http/Requests/TwoFactor/EnableTwoFactorRequest.php
index db8e7c4..ebf40a1 100644
--- a/app/Http/Requests/User/EnableTwoFactorRequest.php
+++ b/app/Http/Requests/TwoFactor/EnableTwoFactorRequest.php
@@ -1,11 +1,8 @@
 <?php
 
-namespace Portal\Http\Requests\User;
+namespace Portal\Http\Requests\TwoFactor;
 
-use Portal\Http\Requests\Request;
-use Portal\User;
-
-class EnableTwoFactorRequest extends Request
+class EnableTwoFactorRequest extends TwoFactorRequest
 {
     /**
      * Get the validation rules that apply to the request.
diff --git a/app/Http/Requests/TwoFactor/ReSendTwoFactorTokenRequest.php b/app/Http/Requests/TwoFactor/ReSendTwoFactorTokenRequest.php
new file mode 100644
index 0000000..4879130
--- /dev/null
+++ b/app/Http/Requests/TwoFactor/ReSendTwoFactorTokenRequest.php
@@ -0,0 +1,7 @@
+<?php
+
+namespace Portal\Http\Requests\TwoFactor;
+
+class ReSendTwoFactorTokenRequest extends TwoFactorRequest
+{
+}
diff --git a/app/Http/Requests/TwoFactor/TwoFactorRequest.php b/app/Http/Requests/TwoFactor/TwoFactorRequest.php
new file mode 100644
index 0000000..b22b6ce
--- /dev/null
+++ b/app/Http/Requests/TwoFactor/TwoFactorRequest.php
@@ -0,0 +1,48 @@
+<?php
+
+namespace Portal\Http\Requests\TwoFactor;
+
+use Portal\Http\Requests\Request;
+use Portal\Repositories\User\UserRepository;
+
+abstract class TwoFactorRequest extends Request
+{
+    /**
+     * Authorize the request.
+     *
+     * @return bool
+     */
+    public function authorize()
+    {
+        if ($userId = $this->get('user')) {
+            // Only users with "users.manage" permission can enable 2FA for other users.
+            return $this->user()->hasPermission('users.manage') || $this->user()->id == $userId;
+        }
+
+        return true;
+    }
+
+    /**
+     * Get the validation rules that apply to the request.
+     *
+     * @return array
+     */
+    public function rules()
+    {
+        return [];
+    }
+
+    /**
+     * Get the user for which we should enable the 2FA.
+     *
+     * @return mixed
+     */
+    public function theUser()
+    {
+        if ($userId = $this->get('user')) {
+            return app(UserRepository::class)->find($userId);
+        }
+
+        return $this->user();
+    }
+}
diff --git a/app/Http/Requests/TwoFactor/VerifyTwoFactorTokenRequest.php b/app/Http/Requests/TwoFactor/VerifyTwoFactorTokenRequest.php
new file mode 100644
index 0000000..44e38ac
--- /dev/null
+++ b/app/Http/Requests/TwoFactor/VerifyTwoFactorTokenRequest.php
@@ -0,0 +1,18 @@
+<?php
+
+namespace Portal\Http\Requests\TwoFactor;
+
+class VerifyTwoFactorTokenRequest extends TwoFactorRequest
+{
+    /**
+     * Get the validation rules that apply to the request.
+     *
+     * @return array
+     */
+    public function rules()
+    {
+        return [
+            'token' => 'required'
+        ];
+    }
+}
diff --git a/app/Listeners/UserEventsSubscriber.php b/app/Listeners/UserEventsSubscriber.php
index ec6c4ef..a85b375 100644
--- a/app/Listeners/UserEventsSubscriber.php
+++ b/app/Listeners/UserEventsSubscriber.php
@@ -2,6 +2,8 @@
 
 namespace Portal\Listeners;
 
+use Lab404\Impersonate\Events\LeaveImpersonation;
+use Lab404\Impersonate\Events\TakeImpersonation;
 use Portal\Activity;
 use Portal\Events\Settings\Updated as SettingsUpdated;
 use Portal\Events\User\Banned;
@@ -147,6 +149,30 @@ class UserEventsSubscriber
         $this->logger->log(trans('log.reseted_password'));
     }
 
+    public function onStartImpersonating(TakeImpersonation $event)
+    {
+        $this->logger->setUser($event->impersonator);
+
+        $message = trans('log.started_impersonating', [
+            'id' => $event->impersonated->id,
+            'name' => $event->impersonated->present()->name
+        ]);
+
+        $this->logger->log($message);
+    }
+
+    public function onStopImpersonating(LeaveImpersonation $event)
+    {
+        $this->logger->setUser($event->impersonator);
+
+        $message = trans('log.stopped_impersonating', [
+            'id' => $event->impersonated->id,
+            'name' => $event->impersonated->present()->name
+        ]);
+
+        $this->logger->log($message);
+    }
+
     /**
      * Register the listeners for the subscriber.
      *
@@ -172,5 +198,7 @@ class UserEventsSubscriber
         $events->listen(TwoFactorDisabledByAdmin::class, "{$class}@onTwoFactorDisableByAdmin");
         $events->listen(RequestedPasswordResetEmail::class, "{$class}@onPasswordResetEmailRequest");
         $events->listen(ResetedPasswordViaEmail::class, "{$class}@onPasswordReset");
+        $events->listen(TakeImpersonation::class, "{$class}@onStartImpersonating");
+        $events->listen(LeaveImpersonation::class, "{$class}@onStopImpersonating");
     }
 }
diff --git a/app/Services/Auth/TwoFactor/Authy.php b/app/Services/Auth/TwoFactor/Authy.php
index e835830..a0435b8 100644
--- a/app/Services/Auth/TwoFactor/Authy.php
+++ b/app/Services/Auth/TwoFactor/Authy.php
@@ -17,7 +17,9 @@ class Authy implements Provider
      */
     public function isEnabled(TwoFactorAuthenticatable $user)
     {
-        return isset($user->getTwoFactorAuthProviderOptions()['id']);
+        $options = $user->getTwoFactorAuthProviderOptions();
+
+        return isset($options['enabled']) && $options['enabled'] === true;
     }
 
     /**
@@ -44,6 +46,22 @@ class Authy implements Provider
         ]);
     }
 
+    /**
+     * {@inheritdoc}
+     */
+    public function sendTwoFactorVerificationToken(TwoFactorAuthenticatable $user)
+    {
+        $key = config('services.authy.key');
+
+        $options = $user->getTwoFactorAuthProviderOptions();
+
+        $response = json_decode((new HttpClient)->get(
+            'https://api.authy.com/protected/json/sms/'.$options['id'].'?force=true&api_key='.$key
+        )->getBody(), true);
+
+        return $response['success'] === true;
+    }
+
     /**
      * Determine if the given token is valid for the given user.
      *
diff --git a/app/Services/Auth/TwoFactor/Contracts/Provider.php b/app/Services/Auth/TwoFactor/Contracts/Provider.php
index a473f2f..e565a1b 100644
--- a/app/Services/Auth/TwoFactor/Contracts/Provider.php
+++ b/app/Services/Auth/TwoFactor/Contracts/Provider.php
@@ -21,6 +21,13 @@ interface Provider
      */
     public function register(TwoFactorAuthenticatable $user);
 
+    /**
+     * Sends an SMS with a phone verification token.
+     * @param Authenticatable $user
+     * @return mixed
+     */
+    public function sendTwoFactorVerificationToken(TwoFactorAuthenticatable $user);
+
     /**
      * Determine if the given token is valid for the given user.
      *
diff --git a/app/Support/CanImpersonateUsers.php b/app/Support/CanImpersonateUsers.php
new file mode 100644
index 0000000..dfcd0f6
--- /dev/null
+++ b/app/Support/CanImpersonateUsers.php
@@ -0,0 +1,28 @@
+<?php
+
+namespace Portal\Support;
+
+trait CanImpersonateUsers
+{
+    /**
+     * Check if a user can impersonate other users.
+     *
+     * @return bool
+     */
+    public function canImpersonate()
+    {
+        return $this->hasPermission('users.manage');
+    }
+
+    /**
+     * Check if a target user can be impersonated.
+     * By default, all users can be impersonated if a currently logged
+     * user is not already impersonating another user.
+     *
+     * @return bool
+     */
+    public function canBeImpersonated()
+    {
+        return ! app('impersonate')->isImpersonating();
+    }
+}
diff --git a/app/Transformers/UserTransformer.php b/app/Transformers/UserTransformer.php
index 15af0f2..6583790 100644
--- a/app/Transformers/UserTransformer.php
+++ b/app/Transformers/UserTransformer.php
@@ -46,6 +46,8 @@ class UserTransformer extends TransformerAbstract
 
     public function includeCountry(User $user)
     {
-        return $this->item($user->country, new CountryTransformer);
+        return $user->country
+            ? $this->item($user->country, new CountryTransformer)
+            : null;
     }
 }
diff --git a/app/User.php b/app/User.php
index c48ae33..07b9ecc 100644
--- a/app/User.php
+++ b/app/User.php
@@ -10,6 +10,7 @@ use Portal\Services\Auth\TwoFactor\Authenticatable as TwoFactorAuthenticatable
 use Portal\Services\Auth\TwoFactor\Contracts\Authenticatable as TwoFactorAuthenticatableContract;
 use Portal\Services\Logging\UserActivity\Activity;
 use Portal\Support\Authorization\AuthorizationUserTrait;
+use Portal\Support\CanImpersonateUsers;
 use Portal\Support\Enum\UserStatus;
 use Illuminate\Auth\Passwords\CanResetPassword;
 use Laracasts\Presenter\PresentableTrait;
@@ -21,7 +22,8 @@ class User extends Authenticatable implements TwoFactorAuthenticatableContract,
         CanResetPassword,
         PresentableTrait,
         AuthorizationUserTrait,
-        Notifiable;
+        Notifiable,
+        CanImpersonateUsers;
 
     protected $presenter = UserPresenter::class;
 
diff --git a/config/app.php b/config/app.php
index 34b3122..a039089 100644
--- a/config/app.php
+++ b/config/app.php
@@ -23,7 +23,7 @@ return [
     | Portal Version
     |--------------------------------------------------------------------------
     */
-    'version' => '3.0.1',
+    'version' => '3.1.0',
 
     /*
     |--------------------------------------------------------------------------
@@ -62,7 +62,7 @@ return [
     |
     */
 
-    'url' => env('APP_URL', 'http://portal.dev'),
+    'url' => env('APP_URL', 'http://portal.test'),
 
     /*
     |--------------------------------------------------------------------------
@@ -214,6 +214,7 @@ return [
         'Artisan'   => Illuminate\Support\Facades\Artisan::class,
         'Auth'      => Illuminate\Support\Facades\Auth::class,
         'Blade'     => Illuminate\Support\Facades\Blade::class,
+        'Broadcast' => Illuminate\Support\Facades\Broadcast::class,
         'Bus'       => Illuminate\Support\Facades\Bus::class,
         'Cache'     => Illuminate\Support\Facades\Cache::class,
         'Config'    => Illuminate\Support\Facades\Config::class,
diff --git a/config/database.php b/config/database.php
index 9653303..8922199 100644
--- a/config/database.php
+++ b/config/database.php
@@ -108,8 +108,8 @@ return [
     | provides a richer set of commands than a typical key-value systems
     | such as APC or Memcached. Laravel makes it easy to dig right in.
     |
-    | Note: Don't forget to uncomment RedisServiceProvider inside config/app.php
-    | file after you install predis package.
+    | NOTE: Don't forget to uncomment RedisServiceProvider inside config/app.php
+    | file after you install predis package!
     |
     */
 
@@ -117,14 +117,19 @@ return [
 
         'client' => 'predis',
 
-        'cluster' => false,
-
         'default' => [
-            'host'     => '127.0.0.1',
-            'port'     => 6379,
-            'database' => 0,
+            'host' => env('REDIS_HOST', '127.0.0.1'),
+            'password' => env('REDIS_PASSWORD', null),
+            'port' => env('REDIS_PORT', 6379),
+            'database' => env('REDIS_DB', 0),
         ],
 
-    ],
+        'cache' => [
+            'host' => env('REDIS_HOST', '127.0.0.1'),
+            'password' => env('REDIS_PASSWORD', null),
+            'port' => env('REDIS_PORT', 6379),
+            'database' => env('REDIS_CACHE_DB', 1),
+        ],
 
+    ],
 ];
diff --git a/config/filesystems.php b/config/filesystems.php
index e5f6e50..77fa5de 100644
--- a/config/filesystems.php
+++ b/config/filesystems.php
@@ -8,14 +8,12 @@ return [
     |--------------------------------------------------------------------------
     |
     | Here you may specify the default filesystem disk that should be used
-    | by the framework. A "local" driver, as well as a variety of cloud
-    | based drivers are available for your choosing. Just store away!
-    |
-    | Supported: "local", "ftp", "s3", "rackspace"
+    | by the framework. The "local" disk, as well as a variety of cloud
+    | based disks are available to your application. Just store away!
     |
     */
 
-    'default' => 'local',
+    'default' => env('FILESYSTEM_DRIVER', 'local'),
 
     /*
     |--------------------------------------------------------------------------
@@ -28,7 +26,7 @@ return [
     |
     */
 
-    'cloud' => 'local',
+    'cloud' => env('FILESYSTEM_CLOUD', 's3'),
 
     /*
     |--------------------------------------------------------------------------
@@ -39,13 +37,15 @@ return [
     | may even configure multiple disks of the same driver. Defaults have
     | been setup for each driver as an example of the required options.
     |
+    | Supported Drivers: "local", "ftp", "sftp", "s3", "rackspace"
+    |
     */
 
     'disks' => [
 
         'local' => [
             'driver' => 'local',
-            'root'   => storage_path('app'),
+            'root' => storage_path('app'),
         ],
 
         'public' => [
@@ -55,20 +55,6 @@ return [
             'visibility' => 'public',
         ],
 
-        'ftp' => [
-            'driver'   => 'ftp',
-            'host'     => 'ftp.example.com',
-            'username' => 'your-username',
-            'password' => 'your-password',
-
-            // Optional FTP Settings...
-            // 'port'     => 21,
-            // 'root'     => '',
-            // 'passive'  => true,
-            // 'ssl'      => true,
-            // 'timeout'  => 30,
-        ],
-
         's3' => [
             'driver' => 's3',
             'key' => env('AWS_ACCESS_KEY_ID'),
@@ -78,16 +64,6 @@ return [
             'url' => env('AWS_URL'),
         ],
 
-        'rackspace' => [
-            'driver'    => 'rackspace',
-            'username'  => 'your-username',
-            'key'       => 'your-key',
-            'container' => 'your-container',
-            'endpoint'  => 'https://identity.api.rackspacecloud.com/v2.0/',
-            'region'    => 'IAD',
-            'url_type'  => 'publicURL',
-        ],
-
     ],
 
 ];
diff --git a/config/hashing.php b/config/hashing.php
index f929cf0..8425770 100644
--- a/config/hashing.php
+++ b/config/hashing.php
@@ -11,10 +11,42 @@ return [
     | passwords for your application. By default, the bcrypt algorithm is
     | used; however, you remain free to modify this option if you wish.
     |
-    | Supported: "bcrypt", "argon"
+    | Supported: "bcrypt", "argon", "argon2id"
     |
     */
 
     'driver' => 'bcrypt',
 
+    /*
+    |--------------------------------------------------------------------------
+    | Bcrypt Options
+    |--------------------------------------------------------------------------
+    |
+    | Here you may specify the configuration options that should be used when
+    | passwords are hashed using the Bcrypt algorithm. This will allow you
+    | to control the amount of time it takes to hash the given password.
+    |
+    */
+
+    'bcrypt' => [
+        'rounds' => env('BCRYPT_ROUNDS', 10),
+    ],
+
+    /*
+    |--------------------------------------------------------------------------
+    | Argon Options
+    |--------------------------------------------------------------------------
+    |
+    | Here you may specify the configuration options that should be used when
+    | passwords are hashed using the Argon algorithm. These will allow you
+    | to control the amount of time it takes to hash the given password.
+    |
+    */
+
+    'argon' => [
+        'memory' => 1024,
+        'threads' => 2,
+        'time' => 2,
+    ],
+
 ];
diff --git a/config/logging.php b/config/logging.php
index 902efaf..400bc7f 100644
--- a/config/logging.php
+++ b/config/logging.php
@@ -1,5 +1,7 @@
 <?php
 
+use Monolog\Handler\StreamHandler;
+
 return [
 
     /*
@@ -25,7 +27,8 @@ return [
     | you a variety of powerful log handlers / formatters to utilize.
     |
     | Available Drivers: "single", "daily", "slack", "syslog",
-    |                    "errorlog", "custom", "stack"
+    |                    "errorlog", "monolog",
+    |                    "custom", "stack"
     |
     */
 
@@ -56,6 +59,14 @@ return [
             'level' => 'critical',
         ],
 
+        'stderr' => [
+            'driver' => 'monolog',
+            'handler' => StreamHandler::class,
+            'with' => [
+                'stream' => 'php://stderr',
+            ],
+        ],
+
         'syslog' => [
             'driver' => 'syslog',
             'level' => 'debug',
diff --git a/config/mail.php b/config/mail.php
index 2354433..ff7a6c8 100644
--- a/config/mail.php
+++ b/config/mail.php
@@ -11,7 +11,8 @@ return [
     | sending of e-mail. You may specify which one you're using throughout
     | your application here. By default, Laravel is setup for SMTP mail.
     |
-    | Supported: "smtp", "mail", "sendmail", "mailgun", "mandrill", "ses", "log"
+    | Supported: "smtp", "sendmail", "mailgun", "mandrill", "ses",
+    |            "sparkpost", "log", "array"
     |
     */
 
@@ -55,8 +56,8 @@ return [
     */
 
     'from' => [
-        'address' => env('MAIL_FROM_ADDRESS', 'test@portal.dev'),
-        'name' => env('MAIL_FROM_NAME', 'Tester')
+        'address' => env('MAIL_FROM_ADDRESS', 'noreply@portal.test'),
+        'name' => env('MAIL_FROM_NAME', 'Portal')
     ],
 
     /*
@@ -123,6 +124,7 @@ return [
     */
     'markdown' => [
         'theme' => 'default',
+
         'paths' => [
             resource_path('views/vendor/mail'),
         ],
